use std::{fs, collections::HashSet};

use anyhow::Result;
use itertools::Itertools;


fn main() -> Result<()> {
    let input = fs::read_to_string("input/03.txt")?;

    let lines: Vec<&str> = input
        .split("\n")
        .filter(|s| *s != "")
        .collect::<Vec<&str>>();

    let result: i32 = lines
        .into_iter()
        .map(|s| s.split_at(s.len() / 2))
        .map(|(one, two)| (one.chars().collect::<HashSet<char>>(), two.chars().collect::<HashSet<char>>()))
        .map(|(one, two)| one.intersection(&two).map(|c| c.clone()).collect_vec())
        .map(sum_priority)
        .sum();
        // .for_each(|s| println!("{:?}", s));

    println!("{:?}", result);
    
    return Ok(());
}

fn sum_priority(entries: Vec<char>) -> i32 {
    return entries
        .into_iter()
        .map(char_to_priority)
        .sum();
}

fn char_to_priority(c: char) -> i32 {
    if c.is_uppercase() {
        return c as i32 - 65 + 27;
    } else {
        return c as i32 - 96;
    }
}
