use std::fs;

use anyhow::Result;
use itertools::Itertools;
use itertools::FoldWhile::*;


fn main() -> Result<()> {
    let input = fs::read_to_string("input/06.txt")?;

    let chars: Vec<char> = input
        .chars()
        .collect_vec();

    let answer = chars
        .into_iter()
        .fold_while((1, ' ', ' ', ' '), |(i, f, s, t), c| {
            if f != s && f != t && f != c && s != t && s != c && t != c && f != '' {
                return Done((i, f, s, t));
            }
            return Continue((i + 1, s, t, c));
        }).into_inner().0;

    println!("{answer}");

    return Ok(());
}
