use std::collections::HashSet;
use std::collections::VecDeque;
use std::fs;

use anyhow::Result;
use itertools::Itertools;
use itertools::FoldWhile::*;


fn main() -> Result<()> {
    let input = fs::read_to_string("input/06.txt")?;

    let chars: Vec<char> = input
        .chars()
        .collect_vec();

    let answer = chars
        .into_iter()
        .fold_while((1, VecDeque::from([' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '])), |(i, mut h), c| {
            if h.iter().collect::<HashSet<&char>>().len() < 14 {
                h.pop_front();
                h.push_back(c);
                return Continue((i + 1, h));
            }

            return Done((i, h));
        }).into_inner().0 - 1;

    println!("{answer}");

    return Ok(());
}
